package cn.iocoder.yudao.module.mes.service.feedingplan;

import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import cn.iocoder.yudao.framework.test.core.ut.BaseDbUnitTest;

import cn.iocoder.yudao.module.mes.controller.admin.feedingplan.vo.*;
import cn.iocoder.yudao.module.mes.dal.dataobject.feedingplan.FeedingRecordPlanDO;
import cn.iocoder.yudao.module.mes.dal.mysql.feedingplan.FeedingRecordPlanMapper;
import cn.iocoder.yudao.framework.common.pojo.PageResult;

import org.springframework.context.annotation.Import;

import javax.annotation.Resource;
import java.util.*;
import java.time.LocalDateTime;

import static cn.hutool.core.util.RandomUtil.*;
import static cn.iocoder.yudao.module.mes.enums.ErrorCodeConstants.*;
import static cn.iocoder.yudao.framework.test.core.util.AssertUtils.*;
import static cn.iocoder.yudao.framework.test.core.util.RandomUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.LocalDateTimeUtils.*;
import static cn.iocoder.yudao.framework.common.util.object.ObjectUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.DateUtils.*;
import static org.junit.jupiter.api.Assertions.*;
import static org.mockito.Mockito.*;

/**
 * {@link FeedingRecordPlanServiceImpl} 的单元测试类
 *
 * @author 内蒙必硕
 */
@Import(FeedingRecordPlanServiceImpl.class)
public class FeedingRecordPlanServiceImplTest extends BaseDbUnitTest {

    @Resource
    private FeedingRecordPlanServiceImpl feedingRecordPlanService;

    @Resource
    private FeedingRecordPlanMapper feedingRecordPlanMapper;

    @Test
    public void testCreateFeedingRecordPlan_success() {
        // 准备参数
        FeedingRecordPlanSaveReqVO createReqVO = randomPojo(FeedingRecordPlanSaveReqVO.class).setId(null);

        // 调用
        Long feedingRecordPlanId = feedingRecordPlanService.createFeedingRecordPlan(createReqVO);
        // 断言
        assertNotNull(feedingRecordPlanId);
        // 校验记录的属性是否正确
        FeedingRecordPlanDO feedingRecordPlan = feedingRecordPlanMapper.selectById(feedingRecordPlanId);
        assertPojoEquals(createReqVO, feedingRecordPlan, "id");
    }

    @Test
    public void testUpdateFeedingRecordPlan_success() {
        // mock 数据
        FeedingRecordPlanDO dbFeedingRecordPlan = randomPojo(FeedingRecordPlanDO.class);
        feedingRecordPlanMapper.insert(dbFeedingRecordPlan);// @Sql: 先插入出一条存在的数据
        // 准备参数
        FeedingRecordPlanSaveReqVO updateReqVO = randomPojo(FeedingRecordPlanSaveReqVO.class, o -> {
            o.setId(dbFeedingRecordPlan.getId()); // 设置更新的 ID
        });

        // 调用
        feedingRecordPlanService.updateFeedingRecordPlan(updateReqVO);
        // 校验是否更新正确
        FeedingRecordPlanDO feedingRecordPlan = feedingRecordPlanMapper.selectById(updateReqVO.getId()); // 获取最新的
        assertPojoEquals(updateReqVO, feedingRecordPlan);
    }

    @Test
    public void testUpdateFeedingRecordPlan_notExists() {
        // 准备参数
        FeedingRecordPlanSaveReqVO updateReqVO = randomPojo(FeedingRecordPlanSaveReqVO.class);

        // 调用, 并断言异常
        assertServiceException(() -> feedingRecordPlanService.updateFeedingRecordPlan(updateReqVO), FEEDING_RECORD_PLAN_NOT_EXISTS);
    }

    @Test
    public void testDeleteFeedingRecordPlan_success() {
        // mock 数据
        FeedingRecordPlanDO dbFeedingRecordPlan = randomPojo(FeedingRecordPlanDO.class);
        feedingRecordPlanMapper.insert(dbFeedingRecordPlan);// @Sql: 先插入出一条存在的数据
        // 准备参数
        Long id = dbFeedingRecordPlan.getId();

        // 调用
        feedingRecordPlanService.deleteFeedingRecordPlan(id);
       // 校验数据不存在了
       assertNull(feedingRecordPlanMapper.selectById(id));
    }

    @Test
    public void testDeleteFeedingRecordPlan_notExists() {
        // 准备参数
        Long id = randomLongId();

        // 调用, 并断言异常
        assertServiceException(() -> feedingRecordPlanService.deleteFeedingRecordPlan(id), FEEDING_RECORD_PLAN_NOT_EXISTS);
    }

    @Test
    @Disabled  // TODO 请修改 null 为需要的值，然后删除 @Disabled 注解
    public void testGetFeedingRecordPlanPage() {
       // mock 数据
       FeedingRecordPlanDO dbFeedingRecordPlan = randomPojo(FeedingRecordPlanDO.class, o -> { // 等会查询到
           o.setRecordId(null);
           o.setRecordDetailId(null);
           o.setPlanId(null);
           o.setItemId(null);
           o.setWeight(null);
           o.setUnitId(null);
           o.setUserId(null);
           o.setFeedingTime(null);
           o.setCreateTime(null);
       });
       feedingRecordPlanMapper.insert(dbFeedingRecordPlan);
       // 测试 recordId 不匹配
       feedingRecordPlanMapper.insert(cloneIgnoreId(dbFeedingRecordPlan, o -> o.setRecordId(null)));
       // 测试 recordDetailId 不匹配
       feedingRecordPlanMapper.insert(cloneIgnoreId(dbFeedingRecordPlan, o -> o.setRecordDetailId(null)));
       // 测试 planId 不匹配
       feedingRecordPlanMapper.insert(cloneIgnoreId(dbFeedingRecordPlan, o -> o.setPlanId(null)));
       // 测试 itemId 不匹配
       feedingRecordPlanMapper.insert(cloneIgnoreId(dbFeedingRecordPlan, o -> o.setItemId(null)));
       // 测试 weight 不匹配
       feedingRecordPlanMapper.insert(cloneIgnoreId(dbFeedingRecordPlan, o -> o.setWeight(null)));
       // 测试 unitId 不匹配
       feedingRecordPlanMapper.insert(cloneIgnoreId(dbFeedingRecordPlan, o -> o.setUnitId(null)));
       // 测试 userId 不匹配
       feedingRecordPlanMapper.insert(cloneIgnoreId(dbFeedingRecordPlan, o -> o.setUserId(null)));
       // 测试 feedingTime 不匹配
       feedingRecordPlanMapper.insert(cloneIgnoreId(dbFeedingRecordPlan, o -> o.setFeedingTime(null)));
       // 测试 createTime 不匹配
       feedingRecordPlanMapper.insert(cloneIgnoreId(dbFeedingRecordPlan, o -> o.setCreateTime(null)));
       // 准备参数
       FeedingRecordPlanPageReqVO reqVO = new FeedingRecordPlanPageReqVO();
       reqVO.setRecordId(null);
       reqVO.setRecordDetailId(null);
       reqVO.setPlanId(null);
       reqVO.setItemId(null);
       reqVO.setWeight(null);
       reqVO.setUnitId(null);
       reqVO.setUserId(null);
       reqVO.setFeedingTime(buildBetweenTime(2023, 2, 1, 2023, 2, 28));
       reqVO.setCreateTime(buildBetweenTime(2023, 2, 1, 2023, 2, 28));

       // 调用
       PageResult<FeedingRecordPlanDO> pageResult = feedingRecordPlanService.getFeedingRecordPlanPage(reqVO);
       // 断言
       assertEquals(1, pageResult.getTotal());
       assertEquals(1, pageResult.getList().size());
       assertPojoEquals(dbFeedingRecordPlan, pageResult.getList().get(0));
    }

}